Bug 67215 - UBO access seems to mask address on nouveau
Summary: UBO access seems to mask address on nouveau
Status: RESOLVED FIXED
Alias: None
Product: Mesa
Classification: Unclassified
Component: Drivers/DRI/nouveau (show other bugs)
Version: git
Hardware: x86-64 (AMD64) Linux (All)
: medium normal
Assignee: Nouveau Project
QA Contact:
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2013-07-23 11:57 UTC by Markus Wick
Modified: 2013-07-24 19:08 UTC (History)
2 users (show)

See Also:
i915 platform:
i915 features:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Markus Wick 2013-07-23 11:57:50 UTC
Hi,

The UBO support seems to be broken when used with dolphin-emu. To try it yourself, I created an apitrace dump:
http://markus.members.selfnet.de/dolphin/dolphin-emu.trace (~48M)
This works fine on i965 and r600g, but it only show some random polygons on nouveau.

This bug only happens when the uniform buffer is bigger than 64k bytes. More precisely it happens when any read offset (related to buffer begin) goes above the 64k mark.
The offset per uniform block is restricted to 64k, but the offsets per uniform buffers should allow to access the complete memory.

It seems that the shader fetch mask locations to the first 64k bytes of the buffer. To proove this, I moved the uniform block to offset 63k so that the first 1k bytes are read correctly and everything else starts at zero.
My uniform buffer was 128k big and I copyed as I wanted to proove and I got a correct rendering.

I think the mask is because of 16bit indices for uniform locations. This is valid for uniform block offsets, but not for uniform buffer offsets.
eg:

u16 uniform_block_offset_per_variable; // hard coded in shader
u32 uniform_buffer_offset_per_uniform_block; // set by glBindBufferRange
u8* uniform_buffer_base; // location of this uniform buffer

// The way I think it's done:
u8* fetched_location = uniform_buffer_base + u16(uniform_buffer_offset_per_uniform_block + uniform_block_offset_per_variable);

// The correct way:
u8* fetched_location = uniform_buffer_base + uniform_buffer_offset_per_uniform_block + u32(uniform_block_offset_per_variable);
Comment 1 Markus Wick 2013-07-24 19:08:44 UTC
fixed by 5c37039797938e43a7dfb6c7d39a1f0bb4f32df3


bug/show.html.tmpl processed on Mar 27, 2017 at 10:42:30.
(provided by the Example extension).